/***************************************************************
      GSM Power Socket

Code for remote control of power socket via call. Program
automaticaly hang up after it detect incoming call. Controling
of power socket is enabled only for number which are stored in
array check_numbers. Before entering number it is neccessary
to check if numbers were displayed with country code (+421)
or without it an then store it in the way how it is displayed.

*///////////////////////////////////////////////////////////////
#include <SoftwareSerial.h>                                     //library for serial communication
#include "SIM900.h"                                             //basic library for comunicating with SIM900
#include "call.h"                                               //library for make & receive call

CallGSM call;                                                   //call class

#define SERIAL_MSGS                                             //enable messages

#define RELAY 7                                                 //pin for RELAY
#define RELAY_ON 0                                              //turn on relay
#define RELAY_OFF 1                                             //turn off relay
boolean RELAY_STATE = RELAY_OFF;                                //default state of relay

char number[20];                                                //phone number
char *check_number[] = {                                        //array of enabled numbers
  "0901234567",                                                 //number 1
  "+421903456789",                                              //number 2
  "0902345678"                                                  //number 3
  };                                                            
byte stat;                                                      //state of incomming call

void setup() 
  {
    Serial.begin(9600);                                         //setup of baudrate
  
    //connection with GSM module
    messages(1,2);                                              //connectiong gsm module
    if (gsm.begin(2400)) messages(2,1);                         //successfull connection with GSM module 
    else messages(3,1);                                         //unsuccessfull connection with GSM module 

    pinMode(RELAY,OUTPUT);                                      //setting pin as output
    digitalWrite(RELAY, RELAY_STATE);                           //setting default state
  }

void loop()
  {
    if(call.CallStatus() == CALL_INCOM_VOICE)                   //checking incomming call
        {
          for (byte i = 0; i < (sizeof(check_number)/2); i++)   //checking array of enabled numbers and comparing it
            {
              stat = call.CallStatusNumber(number,check_number[i]);
              if(stat == CALL_INCOM_VOICE_AUTH) break;          //if call same number then break loop
            }
  
          if(stat == CALL_INCOM_VOICE_AUTH)                     //if calling enabled number
            {
              messages(4,1);
              if(RELAY_STATE == RELAY_ON) RELAY_STATE = RELAY_OFF;    //if previous state of relay is on set it off
              else RELAY_STATE = RELAY_ON;                      //if previous state of relay is off set it on
              digitalWrite(RELAY, RELAY_STATE);                 //set relay state
            }
          
          else messages(5,1);                                   //if calling not enabled number
    
          Serial.print(number);                                 //write incomming number
          call.HangUp();                                        //hang up call
        }
  }

//function for write my debug messages
void messages(byte msg, boolean type)
  {
    #ifdef SERIAL_MSGS
    const char *message;
    switch (msg)
      {
        case 1:
        message = "Making connection with GSM module.";
        break;
        
        case 2:
        message = "\nState: connection established";
        break;
        
        case 3:
        message = "\nState: connections not established";
        break;
        
        case 4:
        message = "\nCalling authorized number: ";
        break;
        
        case 5:
        message = "\nCalling unauthorized number: ";
        break;
      }
    
    if(type == 1) Serial.print(message);
    if(type == 2) Serial.println(message);
    #endif
  }
